package rubrica2;
import java.util.*;
import rubrica.Nominativo;
import rubrica.NominativoPrimaNome;
import rubrica.NominativoPrimaCognome;
import rubrica.NominativoFactory;

public class Rubrica
{

	Map<String, List<Nominativo>> perNome, perCognome, perInput;
	int size = 0;

	public Rubrica()
	{
		perNome = new HashMap<String, List<Nominativo>>();
		perCognome = new HashMap<String, List<Nominativo>>();
		perInput = new HashMap<String, List<Nominativo>>();
	}

	public List<Nominativo> cercaPerNome(String ilNome)
	{
		return perNome.get(ilNome);
	}

	public List<Nominativo> cercaPerCognome(String ilCognome)
	{
		return perCognome.get(ilCognome);
	}

	public List<Nominativo> cercaPerInput(String loInput)
	{
		return perInput.get(loInput);
	}

	public int addNominativo(Nominativo ilNominativo)
	{
		List<Nominativo> l = perNome.get(ilNominativo.getNome());
		if(l == null)
		{
			l = new LinkedList<Nominativo>();
			perNome.put(ilNominativo.getNome(), l);
		}
		l.add(ilNominativo);

		l = perCognome.get(ilNominativo.getCognome());
		if(l == null)
		{
			l = new LinkedList<Nominativo>();
			perCognome.put(ilNominativo.getCognome(), l);
		}
		l.add(ilNominativo);

		l = perInput.get(ilNominativo.toString());
		if(l == null)
		{
			l = new LinkedList<Nominativo>();
			perInput.put(ilNominativo.toString(), l);
		}
		l.add(ilNominativo);

		size++;

		/* se non voglio tenere traccia di inserimenti e rimozioni posso fare in questo modo, cioe' interrogare ogni volta la struttura dati interna
		int retval = 0;
		Collection<List<Nominativo>> cl = perNome.values();
		Iterator<List<Nominativo>> iter = cl.iterator();
		while(iter.hasNext())
		{
			retval += iter.next().size();
		}

		return retval;
		*/

		return size;
	}

	public Nominativo removeNominativo(Nominativo ilNominativo)
	{
		List<Nominativo> l = perNome.get(ilNominativo.getNome());
		int index = l.indexOf(ilNominativo);
		Nominativo retval = l.get(index);
		l.remove(ilNominativo);
		l = perCognome.get(ilNominativo.getCognome());
		l.remove(ilNominativo);
		l = perInput.get(ilNominativo.toString());
		l.remove(ilNominativo);
		size--;
		return retval;
	}

	public String toString()
	{
		String retval = "";
		Collection<List<Nominativo>> nominativi = perNome.values();
		Iterator<List<Nominativo>> iter = nominativi.iterator();
		while(iter.hasNext())
		{
			retval = retval.concat(iter.next().toString() + "; ");
		}
		return retval;
	}
}
