package sequenze;
import java.util.NoSuchElementException;

public class LinkedSequenza<T>
implements Sequenza<T>
{
	NodoDoppio<T> head, tail;
	int count;

	public LinkedSequenza()
	{
		head = tail = null;
		count = 0;
	}

	/*
	public LinkedSequenza(int i)
	{
		this();
	}
	*/

	public T get(int index)
	{
		if(index >= count)
		{
			throw new NoSuchElementException("sei fuori di " + (index-count) + " posizioni");
		}
		NodoDoppio<T> cursore = head;
		while(index-- > 0)
		{
			cursore = cursore.next;
		}
		return cursore.contenuto;
	}

	public int size()
	{
		return count;
	}

	public T set(int index, T element)
	{
		if(index >= count)
		{
			throw new NoSuchElementException();
		}

		NodoDoppio<T> cursore = head;
		while(index-- > 0)
		{
			cursore = cursore.next;
		}
		T retval = cursore.contenuto;
		cursore.contenuto = element;
		return retval;
	}

	public boolean add(T element)
	{
		NodoDoppio<T> tmp = new NodoDoppio<T>(element);

		if(count == 0)
		{
			tail = head = tmp;
		}
		else
		{
			tail.next = tmp;
			tmp.prev = tail;
			tail = tail.next;
		}
		count++;
		return true;
	}

	/**
	* Factory method
	*/
	public SeqIterator<T> seqIterator()
	{
		return new LinkedSeqIterator<T>(this);
	}
}
