package tree;

public class BinTreeNode<T>
{
	BinTreeNode<T> left, right;
	T value;

	public BinTreeNode(T v)
	{
		left = right = null;
		value = v;
	}

	public BinTreeNode()
	{
		this(null);
	}

	public T getValue()
	{
		return value;
	}

	public BinTreeNode<T> getLeftChild()
	{
		return left;
	}

	public BinTreeNode<T> getRightChild()
	{
		return right;
	}

	public String toString()
	{
		return String.valueOf(value);
	}

	public BinTreeNode<T> setLeftChild(BinTreeNode<T> lc)
	{
		BinTreeNode<T> retval = left;
		left = lc;
		return retval;
	}

	public BinTreeNode<T> setRightChild(BinTreeNode<T> rc)
	{
		BinTreeNode<T> retval = right;
		right = rc;
		return retval;
	}

	public T setValue(T v)
	{
		T retval = value;
		value = v;
		return retval;
	}

	public void printInOrder()
	{
		if(getLeftChild() != null)
		{
			getLeftChild().printInOrder();
		}
		System.out.println(value);
		if(getRightChild() != null)
		{
			getRightChild().printInOrder();
		}
	}

	public void printPreOrder()
	{
		System.out.println(value);
		if(getLeftChild() != null)
		{
			getLeftChild().printPreOrder();
		}
		if(getRightChild() != null)
		{
			getRightChild().printPreOrder();
		}
	}

	public void printPostOrder()
	{
		if(getLeftChild() != null)
		{
			getLeftChild().printPostOrder();
		}
		if(getRightChild() != null)
		{
			getRightChild().printPostOrder();
		}
		System.out.println(value);
	}
}
